package Simusol::Algebraico;
use Simusol::Evaluaciones;
use Simusol::Evaluaciones2;
use Simusol::GlobalesSimusol;
use Simusol::Tablasfuncq;
use Simusol::Termicos;
use Simusol::Ayudas;
use Simusol::Controles;

use warnings;
use strict;
use Data::Dumper;
$Data::Dumper::Indent = 1; 
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
                &ajustar_declaraciones_par_ini
                &aumentar_plantilla
                &asignar  
                &asignar_cosa_tipotok
                &asignar_muyprincipales  
                &asignar_tipotok_abrVIalgo
                &asignar_tipotok_nodos
                &asignaciones
                &osignaciones
                &crear_parametro
                &eliminar_pars
                &estandarizar_expresion
                &explot
                &limpiar_unico
                &normalizar
		&QPRODUCTO &QSUMA
                &realizar_ajustes  
                &simpl_constantes
                &simpl_expre_negnum
                &simpl_parametros
                &sust_1par
                &sust_datos_num 
		&sust_par_nap 
                &sust_par 
                &sust_valor_token_en_receptor
                &transformar_h
       );  
};
END();
my $oper = '[\+\-\*\/]'; #la usa limpiar  
# ---------------------------------------------------------------------------
sub asignaciones{# llena $error_cuadros{$que}
  #lo llaman:
  # por aqui pasan los cuadros CONTROLES, USO_DEF,USO, DEFINICION 
  comfin('coml asignaciones', @_);
  my ($ref,$que) = @_;
  my $coderr = '';
  # en $ref->{refvalores}->{$que}->{..}  estan  los renglones tal cual;
  # sin espacios al comienzo, final
  #  se distribuiran en  $ref->{"lista$que"} interpretados  
  # en %hashconvalor se acumulan para hacer control de repetidos
  my $todos = $ref->{refvalores}->{$que};
  my %hashconvalor; my $cuantasdefi = 0;
  my @elemsinicono;
  foreach my $numobj ( keys %$todos) {
      my @lista = @{$todos->{$numobj}};
      impr_debug(__LINE__.' Alge @lista',\@lista);
      my $dearchivo = 0;
      ($coderr,@lista) = juntar_por_signos_y_paren(' ',@lista);
      # el ' ' por si hay una unidad puesta en un segundo renglón
      #impr_debug(__LINE__.' Alge @lista  despues juntar'
      #       ,Dumper [$que,@lista]);
      if ($coderr) {
           comfin('finl asignaciones',__LINE__." $coderr");
           return $coderr;
      };
      map (s/\s+/ /g,@lista); #reduce grupos de espac. a ' '         
      $todos->{$numobj} = \@lista; #por si hay errores poder remirar
      $ref->{definicion} = join("\n", @lista) if $que eq 'DEFINICION';
      foreach my $renglonori (@lista) {
          impr_listas_que(__LINE__.' Alge',$ref,[$que],'lista');
          impr_debug(__LINE__.' Alge $renglonori',$renglonori);
          next unless defined $renglonori;
          my $coment =''; my $renglon = $renglonori;
          if ($renglonori =~ /([^;]*);\s*(.*)$/) {
              $renglon = $1;
              $coment = "$2";
              $renglon =~ s/\s+$//;
              $renglon =~ /\S/ or 
                  do {impr_listas_que(__LINE__.' Alge',$ref,[$que],'lista');
                      cargar_datos_tipotok(
                        $ref,"c$que",$coment,';','','','',[]);
                      impr_listas_que(__LINE__.' Alge',$ref,[$que],'lista');
                       next;             
                  };
          };
         #una primer ",", si no hay ningún signo de igual
          # se interpretaba antes como "=" ; pero ya no; habria que hacer
          #los cambios antes de asignar_tipotok... y no solo aqui 
          #$renglon =~ s/^(\D\w+)\,([^=]*)/$1=$2/;
          if ($renglon =~ /([=,])$/) {
              # solo posible en un  ultimo renglón; incompleto
              $coderr = 22;
              mensajear(
           "Ultimo renglón \"$renglonori\", termina en $1; falta completarlo 
                   en ". descripcion_cuadro($numobj));
               comfin('finl asignaciones',__LINE__." $coderr");
               return $coderr;
          }; 
          my @listita = split (/\s*=\s*/, $renglon);
          my $valorori = $listita[-1];
          my ($refbuenas,$valor);
          if ($que =~ /CONTROLES/) {
              impr_debug(__LINE__.' Alge $renglon',$renglon); 
              $refbuenas = [];
              if (@listita> 2) { 
                  mensajear("No se entiende asignar igual valor a más de un 
                  elemento de $que, como en ". descripcion_cuadro($numobj));
                  next;
              } else {
                 $coderr = asignacion_CONTROLES($ref,\@listita,$numobj,$coment);
                  if (not $coderr) {
                      $refbuenas = [$listita[0]];                   
                  } else {
                      $error_cuadros{$que} = $coderr;
                      mensajear(
        " Mala asignacion por $renglonori en ".descripcion_cuadro($numobj)); 
                      comfin('finl asignaciones',__LINE__,"$coderr");
                      next;
                  };
              };
          };
          impr_debug(__LINE__.' Alge $refbuenas',$refbuenas);
          foreach my $key (@$refbuenas) {
              push @{$hashconvalor{$key}}, $valor; $cuantasdefi ++;
              if ($dearchivo) {
                  $ref->{dearchivo}->{$key} = 1; 
              };
          };
      };#$renglonori @lista
  };  #for $numobj
  if (not $coderr) {
      # control de repetidos 
      impr_debug(__LINE__.' Alge lista$que',$ref->{"lista$que"});
      impr_debug(__LINE__.' Alge %hashconvalor',Dumper \%hashconvalor); 
      if ($cuantasdefi >scalar keys %hashconvalor) {
          avisar_repetidos($ref,$que,\%hashconvalor);
          $coderr = 150;
      };
  };
  comfin('finl asignaciones',__LINE__," $que",'$error_cuadros{$que}',$coderr);
  return $coderr;
}#asignaciones
# ---------------------------------------------------------------------------
sub asignar{ # ya se tiene el tipotok y se ha verificado la existencia SE USA?
# falta detectar los repetidos
  comfin('coml asignar',@_);
  my ($ref,$que) = @_;my $coderr= '';
  my @lista = union_conjunto(@{$ref->{"lista$que"}});
  impr_debug(__LINE__.' Alge @lista',\@lista);
  impr_campo(__LINE__.' Alge $ref',$ref,'ori');
  foreach my $cosa (@lista) {
      my $coderr1= '';
      my $master = $ref->{master}->{$cosa}->[0];
      if ($cosa ne $master) {
          if (valor($ref,'VALOR',$master)) {
              copiar_datos($ref,'',$master,$ref,'',$cosa);
           };      
	  next;
      };
      my @valores = @{$ref->{ori}->{$cosa}};
      if (@valores >1) {
          mensajear (" hay mas de una definicion para $cosa;
           quizas todas corresponden a un mismo valor"); 
      };
      impr_debug(__LINE__.' Alge ',[$que,$cosa,'||',@valores,'||',$master]);
      my ($normal,$nvalor,$tipo,$tiparg,$refarg,$uni,$valor,$coment);
      my @valoreslimpios;
      foreach $valor (@valores) { 
          $coment = '';$valor =~ s/^([^;]+);(.*)$/$1/ and $coment = $2;
          ($coderr1,my($mensaje,$normal,$re),$uni)
            = pre_limpiar_($ref,$que,$valor,$cosa,'Alge'.__LINE__);# en asignar
          if ($coderr1) {
              $coderr .= "$coderr1 ";
              last;
          };
          my ($nvalor,$tipo,$tiparg,$refarg) = @$re;
          push @valoreslimpios,$nvalor;
      };
      impr_debug(__LINE__.' Alge @valoreslimpios',\@valoreslimpios);
      if ($coderr1) {
      };
      @valoreslimpios = union_conjunto(@valoreslimpios);
      if (@valoreslimpios >1) {
          mensajear(
            " Hay mas de una definicion para $cosa; no parecen iguales;
            @valoreslimpios 
               Se ignoran todas");
            next;
      };
      impr_debug(__LINE__.' Alge $tipo,$uni,$coment',[$tipo,$uni,$coment]);
      if ($tipo eq ',') {
              if ($que =~ /^(PEDIDOS|FUNCIONES|DPARAMETROS)$/) {
                      mensajear(" No corresponde ..."); next;
              } elsif ($que =~ /^(PPARAMETROS|DINICIALES|VIINICIALES)$/) {
                  $ref->{TIPOTOK}->{'rerun'.$cosa}
                    = $ref->{TIPOTOK}->{$cosa};
                  cargar_datos($ref,"R$que",'rerun'.$cosa,$nvalor
		   ,$tipo,$tiparg,$refarg);
                  $ref->{TIPOTOK}->{$cosa} = 'b'; 
              } elsif ($que eq 'DATOS') {
                  $ref->{valorcoma2cual}->{$nvalor} or
                  $ref->{valorcoma2cual}->{$nvalor} = $cosa;
              };
      } else {
          if (valor($ref,'TIPOTOK',$cosa) =~ /[pa]/ and 
	      not valor($ref,'TIPOTOK',$nvalor)) {
              $ref->{valor2cual}->{$nvalor} or
                push @{$ref->{valor2cual}->{$nvalor}}, $cosa;
          };
      }; 
      cargar_datos($ref,$que,$cosa,$nvalor,$tipo,$tiparg,$refarg
        ,'',$uni,$valor);
      agregar_comentarios($ref,$cosa,$coment,'Alge '.__LINE__);
      (my $normallimpio = uc($normal)) =~ s/\s+//g;     
      $nvalor eq $normallimpio or
        agregar_comentarios($ref,$cosa,$normallimpio,'Alge '.__LINE__);
  };#$cosa
  impr_campo(__LINE__.' Alge $ref',$ref,'valor2cual');
  impr_datos(__LINE__.' Alge',[$que],$ref); 
  comfin('finl asignar',$que);
  return $coderr;
};#asignar 
# ---------------------------------------------------------------------------
sub asignar_cosa_tipotok{
  comfin('coml asignar_cosa_tipotok',@_);
  my ($ref,$que,$cosa,$valor,$tipotok,$num) = @_;my $coderr = '';
  my ($normal,$nvalor,$tipo,$tiparg,$refarg,$uni);
  impr_dat(__LINE__.' Alge',$cosa,$ref,'act');
  my $eliminado = '';
  if ($eliminado and $ref->{valor2cual}->{$valor}) {
     my $viejo = $ref->{valor2cual}->{$valor}->[0]; 
     my ($vtipotok,$vvalor,$vtipo) = tomar_todo_datos($ref,$viejo);
     if ($vtipo =~ /[adponSs,]/) {
         copiar_cua_datos($ref,$viejo,$cosa);
         agregar_comentarios($ref,$cosa,$viejo,'Alge '.__LINE__);
     } else { 
        cargar_datos($ref,'',$cosa,$viejo,lc($vtipotok),lc($vtipotok),[$viejo]);
        $tipotok eq 'p' and $ref->{TIPOTOK}->{$cosa} = 'P'; 
        agregar_comentarios($ref,$cosa,$valor,'Alge '.__LINE__);
     };
     impr_dat(__LINE__.' Alge',$cosa,$ref,'act');
     comfin('finl asignar_cosa_tipotok linea',__LINE__,$coderr);
     return $coderr;
  };
  (my $coderr1,$normal,my $re,$uni)
    = pre_limpiar($ref,$que,$valor,$cosa,'Alge'.__LINE__);
  if ($coderr1 eq '1') {#significa que hay otra variable con igual valor  asignado, o bien ...
      impr_debug(__LINE__.' Alge $re',$re); 
      my $origen = $ref->{valor2cual}->{$re->[0]}->[0];
      copiar_datos($ref,'',$origen,$ref,'',$cosa);
      agregar_comentarios($ref,$cosa,$origen,'Alge '.__LINE__);
      impr_dat(__LINE__.' Alge',$cosa,$ref,'act');
      comfin('finl asignar_cosa_tipotok linea',__LINE__,$coderr);
      return $coderr;
  }; 
  if ($coderr1 and $coderr1 ne '1') {$coderr .= "$coderr1 ";
      $ref->{TIPOTOK}->{$cosa} = '0';
#      mensajear(" Nos quedamos sin informacion para $cosa: $mensaje
#        en ".descripcion_cuadro($num));
      comfin('finl asignar_cosa_tipotok linea',__LINE__,$coderr);
      return $coderr;
  };
  ($nvalor,$tipo,$tiparg,$refarg) = @$re;
  if ($tipo eq ',') {
      if ($tipotok eq 'd') {
          mensajear(" No corresponde ..."); next;
      } elsif ($tipotok eq 'a') {
          $ref->{valorcoma2cual}->{$nvalor} or
          $ref->{valorcoma2cual}->{$nvalor} = $cosa;
      } elsif ($tipotok =~ /[ijp]/) {
          $ref->{TIPOTOK}->{"rerun$cosa"} = $ref->{TIPOTOK}->{$cosa}; 
          cargar_datos($ref,"R$que",'rerun'.$cosa,$nvalor
	    ,$tipo,$tiparg,$refarg);
          $ref->{TIPOTOK}->{$cosa} = 'b'; 
      };
  } else {
      if (valor($ref,'TIPOTOK',$cosa) =~ /[pa]/ and 
          valor($ref,'TIPO',$nvalor) !~ /[noSspad]/) {
          my $tipotok = valor($ref,'TIPOTOK',$cosa);
          impr_debug(__LINE__.' Alge valor2cual',Dumper $ref->{valor2cual});
          if ($ref->{valor2cual}->{$nvalor}) {
              my $viejo = $ref->{valor2cual}->{$nvalor}->[0];
              my ($vvalor,$vtipo,$tiparg,$refarg)
                = tomar_cua_datos($ref,$viejo);
           } else { 
              push @{$ref->{valor2cual}->{$nvalor}}, $cosa;
          };
      };
  };
  impr_dat(__LINE__.' Alge',$cosa,$ref,'act');
  cargar_datos($ref,$que,$cosa,$nvalor,$tipo,$tiparg,$refarg,'',$uni);     
  agregar_comentarios($ref,$cosa,$normal,'Alge '.__LINE__);
  impr_dat(__LINE__.' Alge',$cosa,$ref,'act');
#  impr_campo(__LINE__.' Alge $ref',$ref,'valor2cual');
  comfin('finl asignar_cosa_tipotok linea',__LINE__,$coderr);
  return $coderr
}#asignar_cosa_tipotok
# ---------------------------------------------------------------------------
sub asignar_muyprincipales{# no incluye INICIALES
  comfin('coml asignar_muyprincipales',@_);
  my $ref = $_[0];my $coderr = '';
  impr_campo(__LINE__.' Alge $ref',$ref,'valor2cual');
  impr_campo(__LINE__.' Alge $ref',$ref,'TIPOTOK');
  impr_debug(__LINE__.' Alge $ref->{listaTIPOTOK}',$ref->{listaTIPOTOK});
  impr_tipotok_valor_ori_num_master_que(__LINE__.' Alge $ref',$ref);
  foreach my $refcosa (@{$ref->{listaTIPOTOK}}) { 
      impr_debug(__LINE__.' Alge $cosa',$refcosa);
      my ($cosa,$tipotok,$ori,$num,$master,$que)
	  = @{$refcosa};
      my $valor = $ori;
      if ($master ne $cosa) {
          my $tipotokm = $ref->{TIPOTOK}->{$master};
          my $tipom = $ref->{TIPO}->{$master};
          impr_debug(__LINE__.' Alge $tipotok,$tipotokm,$tipom'
		     , [$tipotok,$tipotokm,$tipom]);
          if(($tipotok eq 'p' or $tipotok eq 'd' or 
             $tipotok eq 'a') and $ref->{TIPO}->{$master} !~/[,noSs]/) {
           cargar_datos($ref,$que,$cosa,$master,$tipotokm,$tipotokm,[$master]);
              impr_dat(__LINE__.' Alge',$cosa,$ref,'amp');
          } elsif ($ref->{TIPOTOK}->{$master} ne '0') {
              copiar_cua_datos($ref,$master,$cosa);
              my $coment = $ref->{com}->{$master};
              agregar_comentarios($ref,$cosa,$coment,'Alge '.__LINE__);
              impr_dat(__LINE__.' Alge',$cosa,$ref,'amp');
          } else {
              $ref->{TIPOTOK}->{$cosa} = '0';
              mensajear(" Nos quedamos sin informacion para $cosa
              en ".descripcion_cuadro($num));
              next;
          };
      } else {# $master eq $cosa
          asignar_cosa_tipotok($ref,$que,$cosa,$valor,$tipotok,$num);
      };
      if ($tipotok eq 'a') {
          (my $letra = $cosa) =~ s/^(.).*$/$1/;
          $letra eq 'E' and $ref->{TIPOTOK}->{"I$cosa"} = 's' or 
            $letra eq 'J' and $ref->{TIPOTOK}->{"V$cosa"} = 's' or do{
            $ref->{TIPOTOK}->{"V$cosa"} = $ref->{TIPOTOK}->{"I$cosa"} = 's';
	  };
      } elsif ($tipotok eq 'd') {
          (my $parreal = $cosa) =~ s/^D//;
          $ref->{TIPOTOK}->{$parreal} = 's';
      };  
  };#cosa
  foreach my $que (qw(DATOS VIDATOS DPARAMETROS PPARAMETROS)) {
      foreach my $cosa (@{$ref->{"lista$que"}}) {
          $ref->{TIPOTOK}->{$cosa} eq '0' and $cosa = undef;
      };
      @{$ref->{"lista$que"}} = grep($_, @{$ref->{"lista$que"}});
  };
  impr_datos(__LINE__.' Alge',['TODOS'],$ref);
  impr_campo(__LINE__.' Alge $ref',$ref,'valor2cual');
  comfin('finl asignar_muyprincipales');
  return;
};#asignar_muyprincipales 
# ---------------------------------------------------------------------------
sub asignar_tipotok_abrVIalgo{ #no se esta usando
  comfin('coml asignar_tipotok_abrVIalgo',@_);
  my ($numplant,$ref,$abrV,$abrI) = @_;
  $abrV or $abrV= 'V'; $abrI or $abrI = 'I'; 
  $ref->{DEFIabrev}->{$numplant} = {'V'=>$abrV,'I'=>$abrI};
  impr_campo(__LINE__.' Alge $ref',$ref,'DEFIabrev');
  my @nodos;
  my @eles = keys %{$ref->{cualobjele}};
  @eles = grep (do {$_ !~ /^T/ 
            and $plantillalista->[$ref->{cualobjele}->{$_}->[0]] eq $numplant}
         ,@eles);
  foreach my $ele (@eles) {
      my $stringnodos = $ref->{uniuni}->{$ele};
      my @noditos = grep (do{$_ ne '&'},split '-',$stringnodos);
      push @nodos, @noditos;
#      $ref->{TIPOTOK}->{"$ele"} = 'a'; se hace en asignar_tipotok_DATOS
      my $tipo;
      if ($abrV ne 'V') {
          my $Vele = "V$ele"; my $tipo = 's'; 
          if ($Vele =~ s/^VE/E/) {$tipo = 'a'};
          cargar_datos_tipotok($ref,'abrev',"$abrV$ele",'h',"$Vele",$tipo,$tipo
                               ,[$Vele]); 
      };
      if ($abrI ne 'I') {
          my $Iele = "I$ele"; my $tipo = 's';
          if ($Iele =~ s/^IJ/J/) {$tipo = 'a'};
          cargar_datos_tipotok($ref,'h',"$abrI$ele",'h',"$Iele",$tipo,$tipo
                               ,[$Iele]); 
      };
  };
  @nodos = grep( do{ $_ !~ /^[&0]$/},union_conjunto(@nodos));
  #impr_debug(__LINE__.' Alge @nodos',\@nodos);
  foreach my $nodo (@nodos) {
      $ref->{TIPOTOK}->{"$abrV$nodo"} = 'h';
      my ($valor,$tipo) = ("VNODOCIRC$nodo",'');
      if ($ref->{VALOR}->{"VNODOCIRC$nodo"}) {
          $valor = $ref->{VALOR}->{"VNODOCIRC$nodo"};
          $tipo = $ref->{TIPO}->{"VNODOCIRC$nodo"};
      };
      cargar_datos_tipotok($ref,'ABREV',"$abrV$nodo",'h',$valor,$tipo,$tipo
         ,[$valor]);           
  };
  impr_datos(__LINE__.' Alge H',['h'],$ref);
  comfin('finl asignar_tipotok_abrVIalgo');
  return '';
}#asignar_tipotok_abrVIalgo
# ----------------------------------------------------------------------------
sub eliminar_cadenas{
  my $ref = $_[0]; 
  comfin('coml eliminar_cadenas',@_);
  comfin('finl eliminar_cadenas',@_);
  return;
}#eliminar_cadenas
# ----------------------------------------------------------------------------
sub interpretar_tipotok_H{
  comfin('coml interpretar_tipotok_H',@_);
  my ($ref,$valor,$tipotok) = @_; 
  my ($coderr,$nvalor,$ntipo)= ('',$valor,$tipotok);
  impr_debug(__LINE__.' Alge $valor,$ntipo' ,[$valor,$ntipo]); 
  my @partes = @{$ref->{REFARG}->{$valor}};
  my $tipito = $ref->{TIPOTOK}->{$partes[1]};
  impr_debug(__LINE__.' Alge @partes $tipito',[@partes,$tipito]);
  if ($tipito and $tipito eq 'a') {
      my $objele = $ref->{cualobjele}->{$partes[1]}->[0];
      my $numplant = $plantillalista->[$objele];
      impr_debug(__LINE__.' Alge $numplant',$numplant);
      impr_campo(__LINE__.' Alge $ref',$ref,'DEFIequiv');
      my $pre = $ref->{DEFIequiv}->{$numplant}->{$partes[0]};
      $nvalor = "$pre$partes[1]"; $ntipo = 's';
      if ($nvalor =~ s/^VE/E/ or  $nvalor =~ s/^IJ/J/) {
          $ntipo = 'a';
      };
      
     impr_debug(__LINE__.' Alge $nvalor,$ntipo',[$nvalor,$ntipo]);
   } else {
      $nvalor = $ref->{VALOR}->{$valor};
      impr_debug(__LINE__.' Alge $nvalor',[$nvalor]);
      if ($nvalor =~ /^VNODOCIRC/) {
         if ($ref->{TIPOTOK}->{$nvalor} ) { 
             if ($ref->{VALOR}->{$nvalor}) {
                 $nvalor = $ref->{VALOR}->{$nvalor} ;
                 impr_debug(__LINE__.' Alge $nvalor',[$nvalor]);
                 $ntipo = $ref->{TIPOTOK}->{$nvalor};
             } else {
                 $nvalor = cerofuentear($ref,$partes[1]);
                 impr_debug(__LINE__.' Alge $nvalor',$nvalor);
                 $ntipo = 's';
             }
          } else {
              $coderr = 88; return $coderr;
          }; 
      };
#      $ntipotok = $ref->{TIPOTOK}->{$nvalor};
#      if (not $ntipotok) {
#          $nvalor = cerofuentear($ref,$partes[1]);
#          impr_debug(__LINE__.' Alge $nvalor',$nvalor);
#          $ntipotok = 's';
#      };
  };
  impr_par(__LINE__.' Alge clas.tokens',$ntipo,[$nvalor]);
  comfin('finl interpretar_tipotok_H');
  return $coderr,$nvalor,$ntipo;
}
# ----------------------------------------------------------------------------
sub aumentar_plantilla{
  my $nombre = $_[0];
  my $numero = scalar @{$nombreplantilla};
  push(@$nombreplantilla,$nombre);
  $cualplantilla->{$nombre} = $numero;
  return $numero;
} 
# ---------------------------------------------------------------------------
sub estandarizar_expresion{ #lleva numeros a forma estandard
  # y algo sobre espacios 
  # si detecta errores devuelve lo mismo junto con un 
  # codigo de error: s,d,p,f,l
  # s caracteres no admisibles
  # d dobles signos aritmeticos
  # p parentesis mal apareados
  # f faltan operadores
  # l comas invalidas
  # P puntos de más
  # si no detecta error, devuelve expresion estandarizada junto con ''.
  my ($expresion,$que) = @_; my $coderror = '';
  my @listsimbolos = split '', $expresion;
  if ($expresion !~                              /^[\w\.\s\,\(\)\+\-\*\/]+$/) {
       return $_[0],'s' #hay caracteres no admisibles
	   unless $expresion =~                  /^[\w\.\s\,\(\)\+\-\*\/\:]+$/
             and $que  eq 'TABLAS_ARCHIVOS';
  };
  #las posibles XTABLE las lleva a T
  #conviene evitar que el primer argumento de las XTABLE se interprete 
  #como variable y que los XTABLE parezcan indicadores de expresion
  $expresion =~ s/XTABLE\(\s*(T\w+)\,/$1\(/g;
  $expresion =~ /XTABLE/ and 
      avnograv("Expresión con XTABLE no usual
           $_[0];   Se interpreta como indicador de expresión");
  while ($expresion =~ s/(\W)X\w+\s*\(/$1\(/) {}; #saca X.. interiores

  $expresion = '('. $expresion .')';#                 parentesis agregados
  $expresion =~ s/\s([\W\S])/$1/g;$expresion =~ s/([\W\S])\s+/$1/g;
  
  $expresion =~ s/\*\*/\^/g; #para tener operadores de un solo símbolo
  $expresion =~ s/([\(\,])\+/$1/g; #signos + inutiles
  
  #no se ponen las g porque con detectar uno alcanza
  my @haydobles  = ($expresion =~ /([\+\-\*\/\^])([\+\-\*\/\^])/);
  push @haydobles, ($expresion =~ /[\(\,][\*\/\^]/);
  push @haydobles, ($expresion =~ /([\+\-\*\/\^][\)\,])/); 
  push @haydobles, ($expresion =~ /\,\)/);
  push @haydobles, ($expresion =~ /\(\,/);

  @haydobles  and return $expresion, 'd';
  #dobles signos no admisibles

#  $expresion =~ s/\^/\*\*/g; # recuperacion de **

  my $resto = $expresion; my $num = 0; 
  while ($resto and $num >= 0) {
      ($num,my $dat,$resto) = sacar_paren_ext($resto);
      $num >= 0 and $resto and $resto =~ s/^[^\(\)]*//;  
      $resto and $resto =~ /^\)/ and $num = -1;
  };# esto solo se usa para detectar errores; no para simplificar
  $num <0 and return $_[0], 'p'; #parentesis mal apareados
  if (comas_invalidas($expresion)) {
      # expresion viene con sus parentesis exteriores agregados
      $expresion =~ s/^\((.+)\)$/$1/;
      avgrav("Expresion con comas inválidas;\n$expresion");
      return $expresion,'l';
      };

  $expresion =~ /\d/ or do{
       $expresion =~ s/^\((.+)\)$/$1/; # ya no tendra los parent.agregados
       return $expresion, '';# no hay nada más a cambiar
  };
  #my @lissepa = split /[\w\.]+/, $expresion;
  my @lissepa = split /[\w\.\s]+/, $expresion;
  my @lispal = split /[\,\(\)\+\-\*\/\:]+/, $expresion; shift @lispal;
  my @nuelispal;
  for(my $i= 0; $i< @lispal; $i ++) {
      use warnings  FATAL => qw(syntax void);
      my $pal = $lispal[$i];
      $nuelispal[$i] = "$pal$lissepa[$i+1]";
      $pal !~ /^[\.\d]+/ and next;
      if ($pal =~ tr/.// >1) {
          return $expresion, 'P';
      };
      #solo continuan los posibles numeros (digitos y a lo sumo un punto 

      my $valor = eval($pal); 
      if ($@) {
         next unless $i+1 < @lispal and $pal =~ /^[\d\.]+e/i 
                                    and $lispal[$i+1] =~ /^\d+$/;   
	 $pal = "$lispal[$i]$lissepa[$i+1]$lispal[$i+1]";
         $valor = eval($pal);
         if ($@){
             $coderror = 'f';
         } else { 
             my $nvalor = sprintf("%12G",$valor);$nvalor =~ s/\s*//;
             if ($nvalor =~ /E/ and $nvalor !~ /\./) { 
                 $nvalor =~ s/E/.E/;
             };
             $nuelispal[$i] = $nvalor . $lissepa[$i+2];
             $nuelispal[$i+1] = '';
             $i ++;
         }
      } else {
         my $nvalor = sprintf("%12G",$valor);$nvalor =~ s/\s*//;
         $nuelispal[$i] = $nvalor . $lissepa[$i+1];
      };
      $nuelispal[$i] =~ s/^(\d+)(E[+-]\d+)/$1\.$2/;        
      #a sceptre le molesta en las expresiones 5E-4 pero no 5.E-4 
  };#for
  $expresion = $lissepa[0] . join '',@nuelispal; 
  # $lissepa[0] puede tener mas de un simbolo
  while ($expresion =~ s/([^\w\.])1\*/$1/){};
  while ($expresion =~ s/\*1([^\w\.])/$1/){};
  $expresion =~ /(\)\()/ and $coderror = 'f';
  $expresion =~ s/^\((.+)\)$/$1/; # ya no tendra los parent.agregados
  return ($expresion,$coderror);
}# estandarizar_expresion
# ----------------------------------------------------------------------------
sub normalizar{ # siempre return '' #no se usa para circuitos
  #normaliza expresiones para las que sceptre o simusol adnite varias formas
  #comfin('coml normalizar', @_);
  my ($refcirc, $lisque) = @_; my $VAR1;
  my $sepa  = '[\(\)\+\-\*\/\,\=\']';  
  for my $que (@$lisque) {
      my $ref = $refcirc->{$que};  
      next if not defined $ref;
      foreach my $key (keys %{$ref}) {
	  my $valor = $ref->{$key}; $_ = $valor;
          next if $valor =~ /^;/;
#          impr_debug(__LINE__.' Alge $key,$valor', [$key,$valor]); 
          while ($_ =~ s/^\(([^\(\)]+)\)$/$1/) {};
          #saca parentesis exteriores si adentro no los hay 
          $_ =~ s/\s+($sepa)/$1/g; $_ =~ s/($sepa)\s+/$1/g;
          #saca espacios que no revelan  errores 
          #while (s/(\w)\s+(\w)/$1\_$2/){};
          $_ = '('.$_.')'; #para facilitar estudio
	  $valor = $_;
          while (s/($sepa)TIME\s*($sepa)/$1TIEMPO$2/i) {};
          # este cambio para que no se evalue `time` inadvertidamente. 
          s/($sepa)TABL[EA]\s*(\w+)\s*\(/$1T$2\(/gi;
          s/($sepa)E[CQ]UA[TC]ION\s*(\w+)\s*\(/$1Q$2\(/ig;
          s/($sepa)EXPRES{1,2}ION\s*(\w+)\s*\(/$1X$2\(/ig;
          s/(\W)CALCULADO(\W)/$1SIMULADO$2/ig; 
          #no se espera CALCULADO.CALCULADO
          #con el modificador g no consigo hacer lo que quiero
	  $valor = $_;
          while (s/(\w)\s+(\w)/$1&&&$2/){}; #para posiblitar estudio posterior
          s/(\w)&&&(\w)/$1 $2/g; #para posiblitar estudio posterior
          s/^\((.*)\)$/$1/; #los que agregue antes
	  $valor = $_; 
          $ref->{$key} = $valor;
      }; #foreach $key
  };#foreach $que
  #comfin('finl normalizar', $lisque,$refcirc);
  impr_datos(__LINE__.' Alge',['DATOS','PARAMETROS','INICIALES'],$refcirc);
  return '';
} #normalizar
# ----------------------------------------------------------------------------
sub limpiar_unico{# porparar1
  comfin('coml limpiar_unico', @_);
  my ($ref, $lisque) = @_; my $coderr = ''; 
  my @lisque = @$lisque;
  foreach my $que (@lisque) {
      impr_datos(__LINE__.' Alge',[$que],$ref);
      foreach my $key (keys %{$ref->{$que}}) {
          my $datoori = $ref->{$que}->{$key}; my $dato; 
	  impr_debug(__LINE__.' Alge $key $datoori',[$key,$datoori]);
          next if $key eq 'coment';
          next if defined $ref->{"TIP$que"}->{$key} 
	      and $ref->{"TIP$que"}->{$key} eq ';';
           my ($func,$tipo,$tiparg)  = ('','','');
          ($dato,my $coderror) = estandarizar_expresion($datoori,$que);
	  impr_debug(__LINE__.' Alge $key $dato',[$key,$dato]);
                # sin errores sintácticos, si no coderror
          cargar_datos($ref,$que,$key,$dato,'',$coderror,''
                       ,__LINE__.' Alge luego est_expr'); 
          my $reftiparg; 
          if($coderror) {
	      $tipo = 'e'; $tiparg = '';
              $coderror eq 's' and 
                 avgrav("Símbolos no válidos en cuadro $que, $key: $datoori"); 
              $coderror eq 'd' and 
                 avgrav("Sobran operadores en cuadro $que, $key: $datoori"); 
	      $coderror eq 'p' and 
              avgrav("Mal apareo de paréntesis en cuadro $que, $key: $datoori");
              $coderror eq 'f' and
                   avgrav("Faltan operadores en cuadro $que, $key: $datoori"); 
              $coderror eq 'P' and
                   avgrav("Sobran puntos en cuadro $que, $key:) $datoori");
          } else {
              ($coderr,my @listaori)
               = juntar_por_paren_cur(',',split (',', $dato));
impr_debug(__LINE__.' Alge @listaori',\@listaori);
              map(s/&/\-/g,@listaori);
 
             my (@dentrito,@funcito,@tipito,@listargcito,@listanue,@refarg);
	      for (my $i = 0; $i < @listaori; $i ++) {
                  my $cosa = $listaori[$i]; 
                  $cosa = transformar_h($ref,$cosa);
                  ($tipito[$i],$dentrito[$i],$funcito[$i],
                  $listargcito[$i],$listanue[$i],$refarg[$i]) =
                       tipear($cosa,1);
impr_debug(__LINE__.' Alge',[$listargcito[$i],$listanue[$i],$refarg[$i]]); 
     	      };#for $i
              if (@listaori == 1) {
	          $tipo = $tipito[0];
                  $func = $funcito[0];
                  $dato = $listanue[0];
		  $tiparg = $listargcito[0];
                  $reftiparg = $refarg[0];
                  defined $reftiparg or $reftiparg = 0;
	      } else {
                  $dato = 'listalis(' . join(',',@listanue) .')';
                  $tipo =',';
                  $tiparg = join '',@tipito;
                  $reftiparg = \@listanue; 
              };
          };#if else $coderror  
          $avisosgrav and 
          do{ porparar1(171,$ref); 
              return 171};
          cargar_datos($ref,$que,$key,$dato,$tipo,$tiparg,$reftiparg
                       ,__LINE__.' Alge limpiar_un'); 
      };#foreach $key
      impr_datos(__LINE__.' Alge',[$que],$ref);
  }#foreach $que
  comfin('finl limpiar_unico', $lisque,$ref);
  return '';
}#limpiar_unico
# ----------------------------------------------------------------------------
sub transformar_h{
  comfin('coml transformar_h',@_);
  my ($ref,$cosa) = @_;
 # impr_debug(__LINE__.' Alge',Dumper $ref->{cualobjtextonodo});  
 # impr_debug(__LINE__.' Alge',Dumper $ref->{cualobjele});
 # impr_debug(__LINE__.' Alge',$refglobal->{Vs});  
  $cosa = "(;$cosa)";
  while ($cosa =~ /\W;(\w+)\W/) {
     impr_debug(__LINE__.' Alge $cosa',[$cosa,$1]); 
     my $token = $1;my $tokennuevo;
     if (defined $ref->{DATOS}->{$token} or
     	  defined $ref->{PARAMETROS}->{$token} or
     	 $token =~ /^\d/) {
         $tokennuevo = $token; 
    } elsif (defined $refglobal->{equivalente}->{$token}) {
	 $tokennuevo = $refglobal->{equivalente}->{$token};
    } else {
         foreach my $pre (@{$refglobal->{Vs}}) {
             if ($token =~ /^$pre\s*(.+)$/) {
                 my $nodoele = $1;
                 if ($ref->{cualobjele}->{$nodoele}){
                      $tokennuevo = "V$nodoele"; $token =~ s/^VE/E/;
                 } elsif ($ref->{cualobjtextonodo}->{$nodoele}) {
                     if (defined $ref->{uni2TEMP}->{$nodoele}) {
                         my @lista = @{$ref->{uni2TEMP}->{$nodoele}};
                         my @Elista = grep (/^E/,@lista);
                         if (@Elista) {
                             $tokennuevo = $Elista[0];
                         } else {
                             $tokennuevo = $lista[0];
                         }; 
                     };
                 };
             };
	 };
    };
    if (not $tokennuevo) {
        foreach my $pre (@{$refglobal->{Is}}) {
            if ($token =~ /^$pre(.+)$/) {
                my $ele = $1;
                if ($ref->{cualobjele}->{$ele}){
                    $tokennuevo = "V$ele"; $token =~ s/^IJ/J/;
                 };
            };
          }; 
      };
      $tokennuevo and $token = $tokennuevo;
      $cosa =~ s/(\W);(\w+)(\W)/$1$token$3;/;
      impr_debug(__LINE__.' Alge $cosa',$cosa);
  };
  impr_debug(__LINE__.' Alge $cosa',$cosa);
  $cosa =~ s/(\W);/$1/;
  $cosa =~ s/^\((.*)\)$/$1/;
  comfin('finl transformar_h',$cosa);
  return $cosa; 
}
# ----------------------------------------------------------------------------
sub crear_parametro{
  comfin('coml crear_parametro', @_);   
  my ($ref, $iden, $valor) = @_;
  my $ruf = {};
  $valor =~ /\// and do{
     simpl_inversa($ruf,'PARAMETROS','ppp',$valor);# en crear_parametro
     $valor = $ruf->{PARAMETROS}->{ppp};
  };
  # $iden, identificador causante de la necesidad del parametro
  # $valor, lo que valdrá el parametro
  # $ref recibirá de inmediato el parametro, 
  # hay que cuidar que no se identifiquen dos parametros
  # $refcirc recibirá en el futuro el parámetro (cuando llama despl2circ)
  # REVISAR se necesitan los dos?
  my $newpara = $ref->{valuespar}->{$valor};
  # si el identificador es 'd' no aprovecha que ya este definido para el valor
  #porque el valor es irrelevante
  if (defined $newpara and $iden ne 'd' and length $newpara < 7) {
      #ya hay otro parametro valido con igual valor
  } elsif (defined $ref->{PARAMETROS}->{$valor}) {
     $newpara = $valor; #por si el valor simplificado es un parametro  
  } else { 
     my $numpar = 1;
     #en $ref->{parscreados} se mantienen  parametros creados vigentes; 
     #si se borra un parámetro creado anteriormente se borra de ahi
     #comparar con tratamiento de $refcirc->{valuespar}
     while (defined $ref->{PARAMETROS}->{"P$iden$numpar"}) {
        $numpar++;
     };#while
     $newpara = "P$iden$numpar";
     $ref->{parscreados}->{$newpara} = 1;
     $ref->{valuespar}->{$valor} = $newpara; 
     push @{$ref->{listaPARAMETROS}}, $newpara; #en crear_parametros
     my $valorsinamper = $valor;
     $valorsinamper =~ s/&//g;
     my ($tipo,$argus,$func0,$listatiparg,$nvalor,$reflistaarg)
                = tipear($valorsinamper,1); 
     $tipo eq 'e' and 
     porparar1(186,$ref,"Error de sintáxis, en parámetros para $func0,$argus");
     push @{$ref->{lisPARAMETROS}}, $newpara  #en crear:parametros
         unless $tipo =~ /[pane]/;      
     $iden ne 'd' and
     cargar_datos($ref, 'PARAMETROS', $newpara, $nvalor,$tipo,$listatiparg
	   ,$reflistaarg,__LINE__.' Alge crear_par');
     #para $iden 'd' se carga fuera
  };#if elsif else  
  comfin('finl crear_parametro',$valor,$newpara);   
  return $newpara;
}
# ----------------------------------------------------------------------------
sub explot_TQ{
  # todas las argumentos  de funciones Q o tablas deben ser simples
  # no puede haber +-*/
  # se crean parametros PX...
  # seguro que ya no hay llamadas internas a funciones Q
  # porque las ha sacado explot_Q
  # valorpuro sin parentesis
  # y una tabla no puede tener funciones de ningun tipo como argumentos
  my ($ref,$valorpuro) = @_; my $coderr = '';
  my $valorconpar = "($valorpuro)";
  while ($valorconpar =~ /^(.*\W)([TQ]\w+)(\(.+)$/){  
        # or $valorconpar =~ /^(.*\W)(XTABLE)(\(.+)$/) {
      #marcare con ampersand para no volver a encontrarlo
      my ($comi,$func,$restovp) 
               = ($1,$2,$3);
      my ($tipo) = ($func =~ /^(.)/); $tipo = lc($tipo);
      my ($num,$dat,$resdat) = sacar_paren_ext($restovp);
      ($coderr, my @listaarg)
       = juntar_por_signos_y_paren(',',split (',',$dat));
      if ($coderr) {
          porparar1(81,$ref);
          return 81;
      }; 
      my @nuevalistaarg = @listaarg;
      for (my $i=0; $i<@listaarg;$i++) {
           if ($tipo eq 't' and 
                ($listaarg[$i] =~ /\w+\(/)) { 
               $nuevalistaarg[$i]
                      = crear_parametro($ref, 'X', $listaarg[$i])
           };
           next unless $listaarg[$i] =~ /[\+\-\*\/\(\)]/; 
           $nuevalistaarg[$i]
                  = crear_parametro($ref, 'X', $listaarg[$i]);
      };
      $valorconpar = "$comi$func&(" . join(',',@nuevalistaarg) . ")$resdat";
  };#while
  $valorconpar =~ s/\&//g;
  ($valorpuro = $valorconpar) =~ s/^\((.+)\)$/$1/;
  return $coderr,$valorpuro;
} #explot_TQ
# ----------------------------------------------------------------------------
sub explot_Q{
  # todas las menciones internas de funciones Q dan lugar a parámetros PQ
  # valorpuro sin parentesis
  # se crean parametros QQ
  my ($ref,$valorpuro) = @_;
  while ($valorpuro =~ /^(.*\W)(Q\w+)(\(.+)$/) {
      my ($comi,$func,$restovp) 
               = ($1,$2,$3);
      my ($num,$dat,$resdat) = sacar_paren_ext($restovp); 
      my $nuevopar = crear_parametro($ref, 'Q', "$func($dat)");
      $valorpuro = "$comi$nuevopar$resdat"; 
  };
  return $valorpuro; 
} #explot_Q
# ----------------------------------------------------------------------------
sub explot{
  comfin('coml explot', @_); 
  my ($ref,$lisque) = @_; my $coderr = '';
  # se usa una sola vez por diagrama
  # $lisque se refiere a DATOS, PARAMETROS,  etc (no se usa para nada más);
  #  que pueden necesitar 
  # explotar, y siempre. al final de $lisque, estara 
  # PARAMETROS (que aumentará  si hace falta)
  #{listaPARAMETROS} se refiere a lo que va quedando para quizas imprimir
  #{lisPARAMETROS} a lo que hay que revisar para explotar
  # se crean parametros PS o PQ 
  if (not grep (do{$_ eq 'PARAMETROS'},@$lisque)) {
      push @{$lisque}, 'PARAMETROS';
  }; 
  @{$ref->{lisDATOS}} = @{$ref->{listaDATOS}} if defined $ref->{listaDATOS}; 
  @{$ref->{lisPARAMETROS}} = @{$ref->{listaPARAMETROS}} 
      if defined $ref->{listaPARAMETROS};
  #las listas anteriores de parametros son actualizadas por crear parametros
  foreach my $que (@$lisque) {
      foreach my $key (@{$ref->{"lis$que"}}) {
          my ($valor,$tipo,$tiparg,$refarg) = tomar_datos($ref,$que,$key);
          next if not defined $valor; #los modelos quedan indefinidos
          #next if $tipo =~ /[pnabrI]/; 
          next unless $tipo =~ /[xfqt]/; 
          #esta undef si un parametro ha sido  sustituido en todos lados?
          next if $tiparg ne '' and $tiparg =~ /^[pna]+$/;
          my ($func,$dentro) = ($valor =~ /^(\w+)\((.+)\)$/);
          #no puede haber llamadas internas a funciones Q:
          if ($dentro =~ /\WQ\w+\(/) {
              $dentro = explot_Q($ref,$dentro) ;
          #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
              $tiparg =~ s/q/p/g;
	  };
          # los argumentos de tablas y de funciones Q 
          # deben ser simples; ( los argum. de funciones Q pueden ser tablas
          # ahora controlamos 
          # para tablas internas 
	  if ($dentro =~ /\W[QT]\w+\(/ ){ 
              #or $dentro =~ /\WXTABLE\(/) {
              ($coderr,$dentro) = explot_TQ($ref,$dentro);
              if ($coderr) {
                  parar1(81,$ref);
              };
	  };
          if ($tipo =~ /[xf]/) {
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
              if ($dentro =~ /^(\w+)(\(.*)$/) {
                  my $qpal = $1; my $restopal = $2; 
                  my ($num,$dat,$resto) = sacar_paren_ext($restopal);
                  if ($resto eq '' and $num = 0) {
		      $restopal =~ s/\)$//;
                      $func = $qpal; $dentro = $dat;
                  } else {
                      $dentro = explot_Q($ref,";$dentro;");
                      $dentro =~ s/^\;(.*)\;$/$1/;
                  };  
	      } elsif ( $dentro =~ /\WQ\w+\(/) {
                  $dentro = explot_Q($ref,$dentro); 
	      };
              ($tiparg, $refarg, $dentro) = tokensep($dentro);
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
          } elsif ($tipo =~ /[tq]/) {
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
              ($coderr,my @argus)
                = juntar_por_paren_cur(',',split(',',$dentro));
              my @tipargus = split '',$tiparg;
              for (my $j = 0; $j < @argus; $j++) {
		  next if $tipargus[$j] =~ /[pna]/ 
                         or ($tipo eq 'q' and $tipargus[$j] eq 't');
                  $argus[$j] 
                      = crear_parametro($ref, 'S', $argus[$j]);
                  $tipargus[$j] = 'p';
              };#for $j
              $refarg = \@argus; 
              $tiparg = join '',@tipargus;
	      $dentro = join (',', @argus);
              #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
          };#if else  
          #impr_debug(__LINE__.' Alge $func $dentro ',[$func,$dentro]);
	  $valor = "$func($dentro)";
          cargar_datos($ref, $que, $key, $valor, $tipo, $tiparg,$refarg
                               ,__LINE__.' Alge explot');
      };#foreach $key     
  };#foreach $que
  impr_datos(__LINE__.' Alge',$lisque,$ref);
  comfin('finl explot', @{$ref->{lisDATOS}},@{$ref->{lisPARAMETROS}}
                     ,$lisque);
  return ''; 
}#explot
# ---------------------------------------------------------------------------
sub simpl_expre_negnum{
  comfin('comfin simpl_expre_negnum',@_);
  my ($expresin,$posnum) = @_; 
  $expresin =~ s/(.)$//; my $ult = $1; $posnum = -$posnum;
  $ult eq '+' and return "$expresin-", $posnum; 
  $ult eq '-' and return "$expresin+", $posnum;
  $ult =~ /[\(,\,]/ and return @_;
  return $_[0],"($_[1])";
} #simpl_expre_negnum
# ---------------------------------------------------------------------------
sub simpl_inversa{
  comfin('coml simpl_inversa',@_);
  # se usa con todas las expresiones estandarizadas, 
  # por lo que los 1 se aparecen como 1
  my ($ref,$que,$key,$valor) = @_;
  #sustituyo parentesis de tablas (unicas funciones que pueden aparecer aqui
  #abren dod, cierran 3
  #impr_debug(__LINE__.' Alge simpl_inv $key $valor',[$key,$valor]);
  while ($valor =~ s/\((\w+)\)/&&$1&&&/) {};  
  #impr_debug(__LINE__.' Alge simpl_inv $key $valor',[$key,$valor]);
#  $valor =~ s/\*\*/\&/g; 3se cambio antes a ^
  # agrego parentesis exteriores 
  $valor = '('.$valor.')'; 
  #impr_debug(__LINE__.' Alge simpl_inv $valor',$valor);
  my $noopnopar ='[^\+\-\*\/\(\)]';  #acepta el ampersand, lo cual va bien
  my $noop = '[^\+\-\*\/]'; #acepta el ampersand, lo cual va bien 
  my $oppari = '[\+\-\*\/\(]';my $oppard = '[\+\-\*\/\)]'; 
  my $oparit = '[\+\-\*\/]';
  while ($valor =~ 
          s/($noopnopar+)($oparit)\(($noopnopar+)\)/$1$2$3/) {
          #impr_debug(__LINE__.' Alge simpl_inv $valor',$valor);
  };
  while ($valor =~ 
        s/($noopnopar+)\/\(($noopnopar+)\*(($noopnopar+))\)/$1\/$2\/$3/) {
        #impr_debug(__LINE__.' Alge simpl_inv $valor',$valor);
  };
  while ($valor =~ 
          s/($noopnopar+)\/\(($noopnopar+)\/($noopnopar+)\)/$1\/$2\*$3/) {
          #impr_debug(__LINE__.' Alge simpl_inv $key $valor',[$key,$valor]);
  };
  while ($valor =~ 
          s/($noopnopar+)($oparit)\(($noopnopar+)\)/$1$2$2/) {
          #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  };
  $valor = '('.$valor.')'; 
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  while ($valor =~ s/($oppari)\(($noopnopar+)\)/$1$2/) {
     #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  };#saca par. innecesarios  
  while ($valor =~ s/($noopnopar+)\/1\*($noopnopar+)/$1\*$2/){ # 1* xx es xx
     #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  }
  while ($valor =~ s/($noopnopar+)\/1\/($noopnopar+)/$1\/$2/) { # 1* xx es xx
  }
  while ($valor =~ s/([\+\-\(])1\*/$1/){}; # 1* xx es xx
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  while ($valor =~ s/[\*\/]1([\+\-\*\/\)])/$1/) {}; # xx*1, xx/1  es xx
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  # saco los  parentesis exteriores agregados 
  $valor =~ s/^\((.+)\)$/$1/;
  #restituyo los parentesis
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  while ($valor =~ s/&&(\w+)&&&/\($1\)/) {};  
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$valor]);
  my ($tipo,$dentro,$func,$tiparg,$nvalor,$refarg) = tipear($valor,1);
  #impr_debug(__LINE__.' Alge simpl_inv $key, $valor',[$key,$nvalor]);
  cargar_datos($ref,$que,$key,$nvalor,$tipo,$tiparg,$refarg
	       ,__LINE__.' Alge simpl_inversa');
  comfin ('finl simpl_inversa', $nvalor);
} # simpl_inversa
# ----------------------------------------------------------------------------
sub adaptar_mutua{
  my ($refcosa, $que, $mm, $valor) = @_; my $coderr = '';
  my @lista =  split /\s*,\s*/,$valor;
  ($coderr,@lista) = juntar_por_signos_y_paren(',',@lista);
  if ($coderr) {
      parar1(81,$refcosa);
  };
  @lista == 3
      and $lista[0] ne $lista[1]
      and defined $refcosa->{cualobjele}->{$lista[0]}
      and  defined $refcosa->{cualobjele}->{$lista[1]}
      and $lista[0] =~ /^L/ and $lista[1] =~ /^L/
      and do{
         $refcosa->{uni}->{$mm} = "$lista[0]-$lista[1]"; 
         return $lista[2];
      } # do
      or avgrav("Dato imposible para una mutua:   $mm = $valor");
  return "$valor con errores";
}
# ----------------------------------------------------------------------------
sub qpr_qsu{
  comfin('coml qpr_qsu', @_);
  my ($lisque,$ref,$circmod)=@_; my $coderr = '';
  #sust_datos_num($ref,['PARAMETROS','DATOS']);
  foreach my $que (@$lisque) {#no importa el orden
      foreach my $key (keys %{$ref->{$que}}) {#no importa el orden
          my $tipo = $ref->{"TIP$que"}->{$key};
          next if $tipo ne 'q' ;
          my ($dato) = $ref->{$que}->{$key};
          $dato =~ /^(\w+)\s*\((.+)\)/;
          my $func = $1;
	  ($coderr,my @listarg)
            = juntar_por_paren_cur(',',split /,/, $2);
           my $tiplistarg = $ref->{"TIPARG$que"}->{$key};
          my @tiplistarg = split ('', $tiplistarg);
	  $tiplistarg = ''; 
          my ($ff,$num);
          if ($func eq 'QPRODUCTO') {
	      impr_dat(__LINE__.' Alge QPRODUCTO ', $key,$ref,'qq1');
              ($dato, $tipo, $tiplistarg, $ff, $num) =
	        aso_conmu($ref,\@listarg,\@tiplistarg,'*','1','P','0');
              $ref->{"TIPARG$que"}->{$key} = $tiplistarg; 
              $ref->{FUNUSAFUN}->{$ff}->{$num} = 1 if defined $ff;
          } elsif ($func eq 'QSUMA') {
	      impr_dat(__LINE__.' Alge QSUMA ',$key,$ref,'qq1');
              ($dato, $tipo, $tiplistarg, $ff, $num) =
	        aso_conmu($ref,\@listarg,\@tiplistarg,'+','0','S');
              $ref->{"TIPARG$que"}->{$key} = $tiplistarg; 
              $ref->{FUNUSAFUN}->{$ff}->{$num} = 1 if defined $ff;
          } else {
              $ref->{FUNUSAFUN}->{$func}->{scalar @listarg} = 1;
	      next;    
          };
          my ($ntipo,$argus,$nfunc,$listatiparg,$ndato,$reflistaarg) 
                     = tipear($dato,1);
          cargar_datos($ref,$que,$key,$ndato,$ntipo,$listatiparg,$reflistaarg
                           ,__LINE__.' Alge qpr_qsu');
          if ($ntipo eq 'p' and defined $ref->{PARAMETROS}->{$ndato}) { 
              #si no el parametro podria ser TIME o estar dado por su derivada 
	      copiar_datos($ref, 'PARAMETROS', $dato, $ref, $que, $key
                            ,__LINE__.' Alge crar_par');
              $ref->{parssustituidos}->{$dato} = 1;  
          };
      };#foreach $key
  };
  sust_par_nap($ref,'[pan]') #en qpr_qsu
     if $circmod eq 'circuito';
  comfin('finl qpr_qsu',$lisque,$ref);
  return '';
}#qor_qsu
# ---------------------------------------------------------------------------
sub aso_conmu{
  # use warnings  FATAL => qw(numeric uninitialized);
  # devuelve $valor, $tipo  y si $valor contiene funcioncreada
  # (Q2p por ejemplo)
  # devuelve $ff, $num, $listatiparg
  comfin('coml aso_conmu',@_); 
  my ($ref,$refargum,$reftiparg,$oper,$neutro,$simbolo,$absorb) = @_;
  my $resul = $neutro; my (@arg_quedan,@tiparg_quedan);
  for (my $i = 0; $i< @$refargum; $i++) {
     my ($valor,$tipvalor) = ($refargum->[$i],$reftiparg->[$i]);
     return undef,'u','' if not defined $valor or $valor eq '';
     next if $valor eq $neutro;
     return $absorb,'n',''
	if defined $absorb and $tipvalor eq 'n' and $valor == $absorb;
     if ($tipvalor eq 'n') {
        $resul = eval ($resul . $oper . $valor) ;
     } else {
        push @arg_quedan, $valor; push @tiparg_quedan,$tipvalor;	 
     };
  };#for $i 
  $resul = sprintf "%G",$resul; 
  return ($resul,'n','') if @arg_quedan == 0;
  if ($resul != $neutro) {
      unshift @arg_quedan, $resul;
      unshift @tiparg_quedan, 'n';
  };    
  if (@arg_quedan == 1) {
     if ($tiparg_quedan[0] =~ /[pa]/) {
       return ($arg_quedan[0], $tiparg_quedan[0],'')  
     } else { 
       my ($tipo,$argus,$func,$listatiparg,$valor,$reflistaarg) 
              = tipear($arg_quedan[0],1);#en aso_conmu 
       return $valor, $tipo , $listatiparg;
     }
  };
  my $nuefunc ='Q' . scalar @arg_quedan . $simbolo;
  my @virtuales ;
  for (my $i=1; $i<= @arg_quedan;$i++) {
      $virtuales[$i-1] = 'XX' . $i;
  };#for $i 
  my $virtuales = join (',',@virtuales);
  my $valor = '(' .join ($oper,@virtuales) .  ')';
  $ref->{definicionFUNCIONES}->{$nuefunc} = "$nuefunc($virtuales) = $valor";
  $ref->{listaargFUNCION}->{$nuefunc} = \@virtuales;
   impr_debug(__LINE__.' Alge $ref->{definicionFUNCIONES}'
  	   ,Dumper $ref->{definicionFUNCIONES});
  return $nuefunc . '('.join(',',@arg_quedan).')'
         ,'q'
	 , join('',@tiparg_quedan)
	 , $nuefunc
	 , scalar @arg_quedan
	 ;
}#aso_conmu
# ----------------------------------------------------------------------------
sub sust_datos_num{#no esta actualizado
  #sustiuye menciones a parametros o elementos con valor numerico
  #por su valor
  #no se puede aplicar a DATOS antes de desplegar_ele, por la posible
  #confusion con los codigos de formulas
  #se usa luego de haber interpretado RESULTADOS
  #es muy poco eficiente
  comfin('coml sust_datos_num', @_);
  print STDERR __LINE__." line Alge pase por aqui\n"; 
  my ($ref,$lisque,$lisorigen) = @_;
  my (@datosn,@sustn,%quedato,%interesa); my $cuantos = @$lisorigen; 
  my @todosque = union_conjunto(@$lisque,@$lisorigen);
  #impr_datos(__LINE__.' Alge', \@todosque, $ref);
  my $dn= 'dn' . $cuantos;
  map($interesa{$_} = 1, @$lisorigen);
  foreach my $queo (@$lisorigen) {
      my @datqueo = grep (do{$ref->{"TIP$queo"}->{$_} eq 'n'}
                    , keys  %{$ref->{"TIP$queo"}});
      push @datosn, @datqueo;
      map(push(@sustn, $ref->{$queo}->{$_}), @datqueo);
      map($quedato{$_} = $queo,@datqueo);
  };
  # @datosn y @sustn  pueden  crecer si reciben nuevos datos numéricos
  for (my $i= 0; $i < @datosn; $i ++) {
      my $daton  = $datosn[$i]; my $sust = $sustn[$i];
      impr_dat($daton,__LINE__." Alge sust_datos_n", $daton,$ref,'dn0');
      foreach my $que (@$lisque) {
          foreach my $key (keys %{$ref->{$que}}) {
              my ($valor, $tip, $tiparg,$refarg) 
		  = tomar_datos($ref, $que,$key);
	      defined $tip or do{
                 print STDERR 'Aun no se ha llenado bien ',"$que $key en line "
                     , __LINE__, 'Alg',"\n"; 
                   #se da si no se puso en CONTROLES el START .
                 next;
              }; 
              next if $tip =~ /^[nbtPNT;]/; #saque la ,
             # y el p porque sust_cadena_par puede dejar p, por pos. resultado
              $valor =";$valor;";
              my $cambio = 0; 
	      while ($valor =~ s/(\W)$daton(\W)/\&$2/) {
                   $cambio = 1;
                  my ($pre,$sust1) = ($1,$sust);
                  if ($sust < 0) {
		      ($pre,$sust1) = simpl_expre_negnum($pre,$sust1);
                  };
                  $valor =~ s/\&/$pre$sust1/;
              };
	      next unless $cambio;
 	      $valor =~ s/^;(.*);$/$1/;
              my ($tipo,$argus,$func,$listatiparg,$nvalor,$reflistaarg) 
                        = tipear($valor,1);# en sust_datos_num 
              $ref->{parssustituidos}->{$daton} = 1
		  if $quedato{$daton} eq 'PARAMETROS';
              cargar_datos($ref, $que, $key, $nvalor, $tipo, $listatiparg
                         ,$reflistaarg,__LINE__.' Alge sust_d_n');  
              $tipo eq 'q' and $listatiparg =~ /^n+$/ and do{
                  my $coderr = evaluar_q_n($ref, $que, ($key)); #queda cargado
                  return $coderr if $coderr; 
                  impr_dat(__LINE__.' Alge sust_datos_num',$key,$ref,$dn);
                  $tipo = 'n'; 
              };
              $tipo eq 'n'  and $interesa{$que} and do{
		 push @datosn, $key; push @sustn, $ref->{$que}->{$key};
                 $quedato{$key} = $que;
	      };
          };#foreach $key
      };#foreach $que
  };#foreach $daton
  comfin('finl sust_datos_num', $lisque, $ref);
  return '';
}#sust_datos_num
#----------------------------------------------------------------------------
sub sust_1_1{#lo usa eliminar_pars
  comfin('coml sust_1_1', @_);
  my ($refo,$queo,$nombreo,$refd,$qued,$nombred,$mensaje) = @_;
  # sustituye el valor de $nombreo en $nombred,  cumpliendo todo lo necesario
  # ya se habra verificado que $valoro parece  aparecer en $valord 
  # devuelve verdadero, 1  si  pudo hacer la sustitucion
  # falso  '' si no pudo 
  # y si debug, deja registro del nuevo valor, a traves de copiar_datos 
  # o cargar_datos
  # seguro ya se controlo no recursion
  #impr_dat_que($nombred,$qued
  #     ,' Alge sust_1_1 '. $mensaje,$refd,'s11');
  my ($valoro, $tipoo, $tipargo,$refargo)
      = tomar_datos($refo, $queo,$nombreo);
  my ($valord, $tipod, $tipargd,$refargd)
      = tomar_datos($refd, $qued,$nombred);
  #impr_debug(__LINE__.' Alge'
  #   ,[$nombreo,$valoro, $tipoo, $tipargo
  #    ,$nombred,$valord, $tipod, $tipargd]);
  my $ya = '';
  my $nuevovalor = $valord;
  if ($tipod eq 'p'  and $valord eq $nombreo) {
      copiar_datos($refo,$queo,$nombreo,$refd,$qued,$nombred,$mensaje);
        $ya = 1;
  } elsif ($tipod eq 'q' and $tipoo =~ /[napt]/
           or $tipod eq 'x' and $tipoo =~/[ap]/
           or $tipod eq 'x' and $tipoo eq 'n'  and  $valoro >= 0) { 
      while ($nuevovalor =~ s/(\W)$nombreo(\W)/$1$valoro$2/) {
 	  $ya = 1;
      };
  } elsif ( $tipod =~/[xf]/ and $tipoo eq 'n' and $valoro <0) {
      while ($nuevovalor =~ /(\W)$nombreo(\W)/) {
          my ($pre,$post) = ($1,$2);
          my ($pren,$valorn) = simpl_expr_negnum($pre,$valoro);
	  $nuevovalor =~ s/$pre$nombreo$post/$pren$valorn$post/;
	  $ya = 1;
      };
  } elsif ($tipod eq 'x' and $tipoo eq 't') { 
      #se deja para_sceptre_expr el cambiar por XTABLE
      while ($nuevovalor =~ /^(.*\W)$nombreo(\W)/) {
	  my $pre = $1; 
          if ($pre =~ /T.+\($/) {# no debe sust., quedaria argum. complic.
               $nuevovalor =~ s/^(.*\W)$nombreo(\W)/$1\&$2/;
          } else {
               $nuevovalor =~ s/^(.*\W)$nombreo(\W)/$1$valoro$2/;
	  }
      };
      if ($nuevovalor =~ s/\&/$nombreo/g) {
          $ya =''
      } else {
          $ya = 1
      };      
  } else {
  } 
  if ($ya and $tipod ne 'p' and $nuevovalor ne $valord) {
      my ($tipo,$argus,$func0,$listatiparg,$nvalor,$reflistaarg) 
          = tipear($nuevovalor,1);
      cargar_datos($refd,$qued,$nombred,$nvalor,$tipo,$listatiparg
                      ,$reflistaarg,$mensaje); 
  };
  comfin('finl sust_1_1');
  return $ya;
} #sust_1_1  
# ---------------------------------------------------------------------------
sub eliminar_pars{
  comfin('coml eliminar_pars',@_);
# se usa para eliminar parametros que solo se usan una vez 
# siendo valor o parte de solo otro dato que puede recibirlo:
# por ser de tipo p,q,x
# no se puede si es un output; para modulos no tenemos outputs
  my ($ref,$clase,@eliminables) = @_;
  foreach my $par (@eliminables) {
      my $cuantos = 0;
      my ($valorpar,$tipopar,$listatipargpar,$refarg) 
               = tomar_datos($ref,'PARAMETROS',$par 
                        ,__LINE__.' Alge eliminar_par');
      my ($recibe, $qued);
      foreach my $que  ('DATOS','PARAMETROS') {
           my @datos = keys %{$ref->{$que}};
           @datos = grep(do {$_ ne $par and defined $ref->{$que}->{$_} 
		       	and ";$ref->{$que}->{$_};"=~ /$par/} ,@datos);
             @datos == 1 and do{$qued = $que; $recibe = $datos[0]};
              $cuantos += @datos; 
              $cuantos >1 and last;
       };
       next unless $cuantos == 1;
       #impr_debug(__LINE__.' Alge', [$par,$qued,$recibe]);
       my $ya = sust_1_1($ref,'PARAMETROS',$par, $ref,$qued,$recibe
                         ,__LINE__.' Alge eliminar_pars');
       #impr_debug(__LINE__.' Alge', [$par,$qued,$recibe,$ya]);
       if ($ya and $ref->{RESULTADOS}->{lista} !~ /\W$_\W/) {
           borrar_datos($ref,'PARAMETROS',$par,'',__LINE__.' Alge borrar');
             delete $ref->{USAPAR}->{$par};
       };
  };
  comfin('finl eliminar_pars',['DATOS','PARAMETROS'],$ref);
  return '';
} #eliminar_pars
# ---------------------------------------------------------------------------
sub sust_1par{#no esta actualizado 
  comfin('coml sust_1par', @_);
  print STDERR __LINE__ ." line Alge Pase por aqui\n";
  my ($lisque,$refdespl,$viejo,$nuevo,$tiponuevo,$tipargnuevo,$modo)=@_;
  #$lisque no se espera con 'RESULTADOS'
  # cambia nombre $viejo por $nuevo en los hash's indicados por $lisque
  # referenciados por $refdespl: en los values(entre \W o solo el)
  # $nuevo debe ser un atómico 
  # o una tabla;
  # es decir tiponuevo solo puede ser p,n,a,t (t solo recibirán los q)
  # pero ya se ha usado sust_cadena_par por lo que no hay 
  # parametros cuyo valor sea un parametro (salvo con lista de valores)
  # $modo borrar: el tipo del parametro cambia a mayuscula y no se intentara
  # sustituirlo nunca mas; se incorpora a parametros sustutuidos
  # $modo noborrar: corresponde a cambio de valor; el nombre viejo permanece
  #    pero se cambia su valor y su tipo
  # si el cambio corresponde a nuevo parametro,
  # es decir si $nuevo tipo es p ya debe haber sido creado       
  # devuelve 'si' si hubo alguna sustitucion 'no' en caso contrario
  #impr_datos(__LINE__.' Alge sust_1_par', $lisque, $refdespl); 
  if ($viejo eq $nuevo) {
      error_progr($refdespl, __LINE__. " Alge sust_1par viejo $viejo" );
  };
  my $operparcoma = '[\(\)\+\-\*\/\,]';
  if (not defined $modo) {
      error_progr($refdespl,__LINE__.' Alge: sust_1par $modo indefinido ');
  }
  if (not defined $refdespl->{PARAMETROS}->{$viejo}
      #and not defined $refdespl->{PARAMETROS}->{"D$viejo"}
        ){
      error_progr($refdespl,__LINE__.' Alge: sust_1par ');
  };
  #impr_debug(__LINE__.' Alge listaINICIALES',$refdespl->{listaINICIALES} );
  #impr_debug(__LINE__.' Alge INICIALES',$refdespl->{INICIALES} );
  #impr_datos(__LINE__.' Alge sust_1par', $lisque,$refdespl);
  #impr_debug(__LINE__ .' Alge i.d:s_1p |sust_1p',"$viejo=>$nuevo $modo;");
  #impr_debug(__LINE__ .' Alge i.d:s_1p |sust_1p', $lisque);
  foreach my $que (@$lisque) { 
      my @lisvar = sort keys %{$refdespl->{$que}};#recibirán cambios
      @lisvar = grep(lc($refdespl->{"TIP$que"}->{$_}) =~ /[pxfq,]/,@lisvar);
      if (lc($tiponuevo) eq 't') {
           @lisvar =grep ($refdespl->{"TIP$que"}->{$_} =~ /[pq,]/ ,@lisvar);
      } elsif ($tiponuevo =~ /qfx/) {
           @lisvar =grep ($refdespl->{"TIP$que"}->{$_} =~ /[p,]/ ,@lisvar);  
      };
      #impr_debug(__LINE__.' Alge sust_1par reciben (pos):', \@lisvar);
      foreach my $key (@lisvar) {
          my ($valorkey,$tipokey,$listatipargkey,$refarg) 
             = tomar_datos($refdespl,$que,$key ,__LINE__.' Alge sust_1par');
          #impr_dat_que($key,$que,__LINE__.' Alge ',$refdespl,'su1');
          next if $valorkey =~ /^;/ or not defined $tipokey;
          next if $tipokey =~ /[naez]/;
          next unless ";$valorkey;" =~ /\W$viejo\W/;
          #impr_debug(__LINE__ .' Alge i.d:sp '," $key $viejo=>$nuevo $modo");
          if ($valorkey eq $viejo) { #seguro que el $tipokey era  p
              # cambios atomicos
               cargar_datos(
                 $refdespl,$que,$key,$nuevo,$tiponuevo,$tipargnuevo,0
                             ,__LINE__.' Alge sust_1par');
               $refdespl->{parssustituidos} ->{$viejo} = 1;
               next;
       	  };
          # si es p sera otro distinto de $viejo
          # se han cambiado los $viejo que aparecían en forma atomica; 
          # faltan los que aparecen integrando moleculas
          # quedan todos con $func o 'X..'         
          error_progr($refdespl,__LINE__.' Alge sust_1par no hay func'  
                                . " $key $valorkey")
                unless $valorkey =~ /(\w+)(\(.+\))/;
	 my $func = $1; my $argus = $2; my $tipo; my $listatiparg;
         my $cambio =''; # $argus con sus parentesis
         #impr_debug(__LINE__.' Alge sust_1par $argus', $argus);  
         while ($argus  
	        =~ s/($operparcoma)(\s*)($viejo)(\s*$operparcoma)/\&$4/i) { 
            $cambio = 1;
            my ($oper1,$nuevo1) = ($1,$nuevo);
	    if ($tiponuevo eq 'n' and $nuevo1 < 0) {
		($oper1, $nuevo1) = simpl_expr_negnum($oper1,$nuevo1);
            };
            $argus =~ s/\&/$oper1$nuevo1/;
	};#while  
        #impr_debug(__LINE__.' Alge sust_1par $argus', $argus);  
        next unless $cambio;
        $refdespl->{parssustituidos}->{$viejo} = 1; 
	$argus =~ s/^\((.+)\)$/$1/;
        if ($tiponuevo ne 'p') {
	      #si fuera igual a p no cambiaria el tiparg ni el tipo
            ($tipo,$argus,$func,$listatiparg,my $valor,my $reflistaargus) 
                = tipear("$func($argus)",1);#en sust_1par 
            cargar_datos($refdespl, $que, $key, $valor, $tipo, $listatiparg
                     ,$reflistaargus,__LINE__.' Alge sust_1par');
            $tipo eq 'q' and $listatiparg =~ /^n+$/ and do {
                my $coderr = evaluar_q_n($refdespl,$que,($key)); 
                $coderr and return $coderr}; 
	} else {
            $refdespl->{$que}->{$key} = "$func($argus)";
	};
        impr_dat(__LINE__.' Alge sust_1par',$key,$refdespl,'sp2');
     };#foreach $key de @lisvar
  };#foreach $que 
  impr_dat(__LINE__.' Alge sust_1par',$viejo,$refdespl,'sp3');
  if ($modo eq 'borrar' and $viejo ne $nuevo ) {
      $refdespl->{TIPPARAMETROS}->{$viejo} 
            = uc($refdespl->{TIPPARAMETROS}->{$viejo});
  } elsif ($modo eq 'noborrar'){
      $refdespl->{PARAMETROS}->{$viejo} = $nuevo;
      $refdespl->{TIPPARAMETROS}->{$viejo} = $tiponuevo;
      # REVISAR por TIPARGPA...  };#if
      impr_dat(__LINE__.' Alge sust_1par',$viejo,$refdespl,'sp3');
  };
  comfin('finl sust_1par',$lisque,$refdespl);
  return '';
};     
# ----------------------------------------------------------------------------
sub simpl_parametros{#no esta actualizado
  #sustituye parametros atomicos (o tablas) en otros parametros   
  #detecta recursion simple
  comfin('coml simpl_parametros', @_);
  print STDERR __LINE__." line Alge Pase por aqui\n";
  my $refc = $_[0]; my $coderr; 
  my @params1 = sort keys %{$refc->{PARAMETROS}};
  my @params = @{$refc->{listaPARAMETROS}};  
  @params = grep($_ !~ /^\;/,@params);
  my @inicintegr = grep(defined $refc->{PARAMETROS}->{"D$_"}, @params);
  #impr_datos(__LINE__.' Alge', ['PARAMETROS','INICIALES'], $refc);
  @params = grep(do{not defined $refc->{PARAMETROS}->{"D$_"}},@params);
  #impr_debug(__LINE__.' Alge @params', \@params);
  my @evaluables =  grep(do{$refc->{TIPPARAMETROS}->{$_} eq 'q'
                           and $refc->{TIPARGPARAMETROS}->{$_} =~ /^n+$/ 
                         }, @params);
  if (@evaluables) {
      $coderr = evaluar_q_n($refc,'PARAMETROS',@evaluables);
      return $coderr if $coderr;
  };
  my @atomicos = grep(do{$refc->{TIPPARAMETROS}->{$_}
             and $refc->{TIPPARAMETROS}->{$_} =~ /[nap]/}, @params); 
  return '' unless @atomicos;
  my @cambiables = grep(do{$refc->{TIPPARAMETROS}->{$_} =~ /[xqt]/
                           and $refc->{TIPARGPARAMETROS}->{$_} =~ /p/
                          }, @params);
  @cambiables = union_conjunto(@cambiables);
  if (@cambiables) {
      #los atomicos pueden crecer y los cambiables (se recalculan)  disminuir
      foreach my $ato (@atomicos) {
          last unless @cambiables;
          next if $refc->{parssustituidos}->{$ato};
          my $valorato = $refc->{PARAMETROS}->{$ato}; 
          my $sustato = '';
          my $tipvalorato = $refc->{TIPPARAMETROS}->{$ato};
          #no hay peligro de recursion; ya se controlo
          foreach my $cam (@cambiables) {
	      my $cambiocam = '';
	      my $valorcam = ';' . $refc->{PARAMETROS}->{$cam} . ';';
              next unless $valorcam =~ /\W$ato\W/; #no hace falta
              while ($valorcam =~ s/(\W)\s*$ato\s*(\W)/\&$2/i){
                  my ($pre,$valorato1) = ($1, $valorato);  
                  if ($tipvalorato eq 'n' and $valorato1 <0) {
		      ($pre, $valorato1) 
                           = simpl_expre_negnum($pre,$valorato1);
                  };                  
                  $valorcam =~ s/\&/$pre$valorato1/;    
	          $cambiocam =1; $sustato = 1;
	      };
	      $cambiocam and do{
                $valorcam =~ s/^;(.+);$/$1/;
	        my ($tipo, $argus, $func, $listatiparg
                    , $nvalor,$reflistaargus) = tipear($valorcam,1);
	          cargar_datos(
                    $refc, 'PARAMETROS', $cam, $nvalor, $tipo, $listatiparg
                          , $reflistaargus, __LINE__.' Alge simpl_par');
	          $tipo =~ /[nap]/ and $cam =~ /^P/ and push @atomicos, $cam;
	      };
          }; #cambiables
          $sustato  and do{
              $refc->{parssustituidos}->{$ato} = 1;
          };
	  @cambiables = grep($refc->{TIPARGPARAMETROS}->{$_} =~ /p/
				 ,@cambiables);
          @cambiables = union_conjunto(@cambiables);
      };
      @evaluables =  grep(do{$refc->{TIPPARAMETROS}->{$_} eq 'q'
                           and $refc->{TIPARGPARAMETROS}->{$_} =~ /^n+$/ 
                         }, @params);
      if (@evaluables) {
          @evaluables = union_conjunto(@evaluables); 
          $coderr = evaluar_q_n($refc,'PARAMETROS',@evaluables);
          return $coderr if $coderr;
          push @atomicos, @evaluables;
      };
  };
  comfin('finl simpl_parametros',['PARAMETROS'], $refc);
  return '';
}
# ----------------------------------------------------------------------------
sub sust_par_nap{# no esta actualizada
  # lo llaman qpr_qsu,desplegar_ele,desplegar_mod
  comfin('coml sust_par_nap', @_);
  print STDERR __LINE__." line Alge Pase por aqui\n";
  # sustituye todos los parametros con tipo que responde a $reg 
  # (casi siempre $reg es /[nap]/)
  # y como nunca más debera sustituir, cambia el tipo a su mayuscula
  # (nunca elimina del todo los parámetros)
  my ($ref,$reg) = @_;
  #impr_datos(__LINE__.' Alge sust_par_nap', ['PARAMETROS'], $ref);
  my @lispartotal
      = grep ($_ !~ /^D/, sort keys %{$ref->{PARAMETROS}}); # en sust_par_nap
  # los otros se llevaran a controlar_integrables
  my @lispar = grep ($ref->{TIPPARAMETROS}->{$_} =~ /$reg/, @lispartotal);
  my $lisque = ['DATOS','PARAMETROS'];
  while (@lispar) {#esta lista de parámetros va cambiando 
      foreach my $par (@lispar) {
          my ($valor,$tipopar,$tipargpar,$refarg) =
               tomar_datos($ref,'PARAMETROS',$par
			   , __LINE__.' Alge sust_par_nap');
          error_progr($ref, ' Alge: sust_par_nap - recursividad ' . __LINE__)
              if $par eq $valor;
              # no debe ocurrir porque se ha controlado recursion
          my $modo = 'borrar';
          sust_1par($lisque, $ref, $par, $valor, $tipopar,'' #en sust_par_nap
                   ,$modo,__LINE__.' Alge en sust_par_nap');
          $ref->{TIPPARAMETROS}->{$par} = uc($ref->{TIPPARAMETROS}->{$par}) 
                if $modo eq 'noborrar';
      };#foreach $par
      # pueden aparecer más parametros con valor tipo n
      @lispartotal 
         = grep ($_ !~ /^D/, sort keys %{$ref->{PARAMETROS}});#en sust_par_nap 
      # el anterior @lispartotal se pudo haber modif.
      @lispar = grep ($ref->{TIPPARAMETROS}->{$_} =~ /$reg/, @lispartotal);
  };#while 
  comfin('finl sust_par_nap',$lisque, $ref);
  return '';
}#sust_par_nap     
# ----------------------------------------------------------------------------
sub realizar_ajustes{
  comfin('coml realizar_ajustes', @_);
  my ($ref,$circmod) = @_;
  my @controles = keys %{$ref->{CONTROLES}};
  foreach my $key (@controles) {
      my ($valor,$tipo,$tiparg,$refarg) = tomar_datos($ref,'CONTROLES',$key);
      next if $tipo =~ /[an;\,]/;
      if ($tipo eq 'p') {
          my ($valorp,$tipop,$tipargp,$refargp) 
            = tomar_datos($ref,'PARAMETROS',$valor);
          if ($tipop =~ /[n\,]/) {
              cargar_datos($ref,'CONTROLES',$key, $valorp,'n','');
              $ref->{USAPARCONTROLES}->{$valor} = 1;
              last;
          };
      };
      parar1(66,$ref,"$key, del cuadro CONTROLES no consiguió
                  un valor numérico sino $valor");     
  };    
  qpr_qsu(['PARAMETROS','DATOS','INICIALES'], $ref,$circmod);
  ajustar_definiciones($ref);
  comfin('finl realizar_ajustes');
  return '';
}
#------------------------------------------------------------------------------
sub ajustar_definiciones{
  comfin('coml ajustar_definiciones', @_);
  #sustituye parametros con valor tipo tabla en funciones Q y en expresiones
  #antepone 'XXX' para funciones 'f' o variables extrañas
  # elimina doblesparentesis
  my $ref = $_[0];
  # f.FORTRAN en expres  numerar expresiones
  my $lisque = ['DATOS','PARAMETROS']; #saque el RESULTADOS
  foreach my $que (@$lisque) {
      foreach my $key (sort keys %{$ref->{$que}}) {#importa el orden
          my ($dato,$tipo,$tiparg,$refarg)
               = tomar_datos($ref,$que,$key,__LINE__.' Alge aj.def');
          my $cambio = 0;
          $dato = "($dato)";
          if ($cambio) {
              $dato =~ s/^\((.+)\)$/$1/;
 	      $ref->{$que}->{$key} = $dato;
          };
          $dato =~ s/^\((.+)\)/$1/;
          next unless $tipo =~ /[afx]/;

          # las funciones de fortran y las variables del sceptre no pueden
          # estar solas; si o si deben estar en expresiones
          if ($tipo =~ /[a]/) {
              $ref->{"TIPARG$que"}->{$key} = $ref->{"TIP$que"}->{$key};
              $ref->{$que}->{$key} = "XXX($ref->{$que}->{$key})";
	      $ref->{"TIP$que"}->{$key} ='x';
              $ref->{"REFARG$que"}->{$key} = [$dato];
              $dato = "$ref->{$que}->{$key}";
	  } elsif ($tipo eq 'f') {
              my ($func,$dentro);
              if ($dato =~ /^(\w+)\((.+)\)/) {
                 ($func,$dentro) = ($1,$2);
	      } else {error_progr($ref,__LINE__.' Alge  inesperado');
              };  
              ($tiparg,$refarg,$dentro) = tokensep($dentro);
              cargar_datos($ref,$que,$key,"XXX($func($dentro))",'x',$tiparg
                           ,$refarg
			   ,__LINE__.' Alge  aj.def');
          }
          #los identificadores de expresiones no pueden estar repetidos
      }; # key
  };# $que 

  my @lispar = sort keys %{$ref->{PARAMETROS}}; # en ajustar_definiciones
  my @lispart = grep(lc($ref->{TIPPARAMETROS}->{$_}) eq 't',@lispar);

  # sustituye con precauciones del caso los parametros con valor tabla
  foreach my $par (@lispart) {
      my $valor = $ref->{PARAMETROS}->{$par};
      my $tiparg = $ref->{TIPARGPARAMETROS}->{$par};
      my $lisque = ['PARAMETROS','DATOS'];
      sust_1par($lisque,$ref,$par,$valor,'t',$tiparg,'noborrar'); #ajus_def.
  };
  my @lisparx =  grep($ref->{TIPPARAMETROS}->{$_} =~ /[xf]/,@lispar);
  foreach my $par (@lisparx) {
      my $valor = $ref->{PARAMETROS}->{$par};
      next unless $valor =~/\//;
      impr_dat(__LINE__.' Alge aj_def',$par,$ref,'aj');
      simpl_inversa($ref,'PARAMETROS',$par,$valor); #en ajustar_definic
  };
  my @lisdatx =  grep($ref->{TIPDATOS}->{$_} =~ /[xf]/,keys %{$ref->{DATOS}});
  foreach my $dat (@lisdatx) {
      my $valor = $ref->{DATOS}->{$dat};
      next unless $valor =~/\//;
      impr_dat(__LINE__.' Alge aj_def',$dat,$ref,'aj');
      simpl_inversa($ref,'DATOS',$dat,$valor); #en ajustar_definic
  };

  comfin('finl ajustar_definiciones', ['DATOS','PARAMETROS'] , $ref);
  return ''; 
} #ajustar_definiciones 
1;
